/[gentoo-x86]/eclass/haskell-cabal.eclass
Gentoo

Diff of /eclass/haskell-cabal.eclass

Parent Directory Parent Directory | Revision Log Revision Log | View Patch Patch

Revision 1.18 Revision 1.26
1# Copyright 1999-2006 Gentoo Foundation 1# Copyright 1999-2012 Gentoo Foundation
2# Distributed under the terms of the GNU General Public License v2 2# Distributed under the terms of the GNU General Public License v2
3# $Header: /var/cvsroot/gentoo-x86/eclass/haskell-cabal.eclass,v 1.18 2010/01/26 20:50:40 kolmodin Exp $ 3# $Header: /var/cvsroot/gentoo-x86/eclass/haskell-cabal.eclass,v 1.26 2012/01/20 18:24:09 slyfox Exp $
4# 4
5# @ECLASS: haskell-cabal.eclass
6# @MAINTAINER:
7# Haskell herd <haskell@gentoo.org>
8# @AUTHOR:
5# Original authors: Andres Loeh <kosmikus@gentoo.org> 9# Original author: Andres Loeh <kosmikus@gentoo.org>
6# Duncan Coutts <dcoutts@gentoo.org> 10# Original author: Duncan Coutts <dcoutts@gentoo.org>
7# Maintained by: Haskell herd <haskell@gentoo.org> 11# @BLURB: for packages that make use of the Haskell Common Architecture for Building Applications and Libraries (cabal)
8# 12# @DESCRIPTION:
9# This eclass is for packages that make use of the
10# Haskell Common Architecture for Building Applications
11# and Libraries (cabal).
12#
13# Basic instructions: 13# Basic instructions:
14# 14#
15# Before inheriting the eclass, set CABAL_FEATURES to 15# Before inheriting the eclass, set CABAL_FEATURES to
16# reflect the tools and features that the package makes 16# reflect the tools and features that the package makes
17# use of. 17# use of.
18# 18#
19# Currently supported features: 19# Currently supported features:
20# haddock -- for documentation generation 20# haddock -- for documentation generation
21# hscolour -- generation of colourised sources
21# alex -- lexer/scanner generator 22# alex -- lexer/scanner generator
22# happy -- parser generator 23# happy -- parser generator
23# c2hs -- C interface generator 24# c2hs -- C interface generator
24# cpphs -- C preprocessor clone written in Haskell 25# cpphs -- C preprocessor clone written in Haskell
25# profile -- if package supports to build profiling-enabled libraries 26# profile -- if package supports to build profiling-enabled libraries
26# bootstrap -- only used for the cabal package itself 27# bootstrap -- only used for the cabal package itself
27# bin -- the package installs binaries 28# bin -- the package installs binaries
28# lib -- the package installs libraries 29# lib -- the package installs libraries
29# nocabaldep -- don't add dependency on cabal. 30# nocabaldep -- don't add dependency on cabal.
30# only used for packages that _must_ not pull the dependency 31# only used for packages that _must_ not pull the dependency
31# on cabal, but still use this eclass (e.g. haskell-updater). 32# on cabal, but still use this eclass (e.g. haskell-updater).
32# 33#
33# Dependencies on other cabal packages have to be specified 34# Dependencies on other cabal packages have to be specified
34# correctly. 35# correctly.
35# 36#
36# Cabal libraries should usually be SLOTted with "${PV}". 37# Cabal libraries should usually be SLOTted with "${PV}".
43# Special flags to Cabal Configure can now be set by using 44# Special flags to Cabal Configure can now be set by using
44# CABAL_CONFIGURE_FLAGS 45# CABAL_CONFIGURE_FLAGS
45 46
46inherit ghc-package multilib 47inherit ghc-package multilib
47 48
49# @ECLASS-VARIABLE: CABAL_EXTRA_CONFIGURE_FLAGS
50# @DESCRIPTION:
51# User-specified additional parameters passed to 'setup configure'.
52# example: /etc/make.conf: CABAL_EXTRA_CONFIGURE_FLAGS=--enable-shared
53: ${CABAL_EXTRA_CONFIGURE_FLAGS:=}
54
55# @ECLASS-VARIABLE: GHC_BOOTSTRAP_FLAGS
56# @DESCRIPTION:
57# User-specified additional parameters for ghc when building
58# _only_ 'setup' binary bootstrap.
59# example: /etc/make.conf: GHC_BOOTSTRAP_FLAGS=-dynamic to make
60# linking 'setup' faster.
61: ${GHC_BOOTSTRAP_FLAGS:=}
62
63HASKELL_CABAL_EXPF="pkg_setup src_compile src_test src_install"
64
65case "${EAPI:-0}" in
66 2|3|4) HASKELL_CABAL_EXPF+=" src_configure" ;;
67 *) ;;
68esac
69
70EXPORT_FUNCTIONS ${HASKELL_CABAL_EXPF}
48 71
49for feature in ${CABAL_FEATURES}; do 72for feature in ${CABAL_FEATURES}; do
50 case ${feature} in 73 case ${feature} in
51 haddock) CABAL_USE_HADDOCK=yes;; 74 haddock) CABAL_USE_HADDOCK=yes;;
75 hscolour) CABAL_USE_HSCOLOUR=yes;;
76 hoogle) CABAL_USE_HOOGLE=yes;;
52 alex) CABAL_USE_ALEX=yes;; 77 alex) CABAL_USE_ALEX=yes;;
53 happy) CABAL_USE_HAPPY=yes;; 78 happy) CABAL_USE_HAPPY=yes;;
54 c2hs) CABAL_USE_C2HS=yes;; 79 c2hs) CABAL_USE_C2HS=yes;;
55 cpphs) CABAL_USE_CPPHS=yes;; 80 cpphs) CABAL_USE_CPPHS=yes;;
56 profile) CABAL_USE_PROFILE=yes;; 81 profile) CABAL_USE_PROFILE=yes;;
65if [[ -n "${CABAL_USE_HADDOCK}" ]]; then 90if [[ -n "${CABAL_USE_HADDOCK}" ]]; then
66 IUSE="${IUSE} doc" 91 IUSE="${IUSE} doc"
67 DEPEND="${DEPEND} doc? ( dev-haskell/haddock )" 92 DEPEND="${DEPEND} doc? ( dev-haskell/haddock )"
68fi 93fi
69 94
95if [[ -n "${CABAL_USE_HSCOLOUR}" ]]; then
96 IUSE="${IUSE} hscolour"
97 DEPEND="${DEPEND} hscolour? ( dev-haskell/hscolour )"
98fi
99
70if [[ -n "${CABAL_USE_ALEX}" ]]; then 100if [[ -n "${CABAL_USE_ALEX}" ]]; then
71 DEPEND="${DEPEND} dev-haskell/alex" 101 DEPEND="${DEPEND} dev-haskell/alex"
72 cabalconf="${cabalconf} --with-alex=/usr/bin/alex"
73fi 102fi
74 103
75if [[ -n "${CABAL_USE_HAPPY}" ]]; then 104if [[ -n "${CABAL_USE_HAPPY}" ]]; then
76 DEPEND="${DEPEND} dev-haskell/happy" 105 DEPEND="${DEPEND} dev-haskell/happy"
77 cabalconf="${cabalconf} --with-happy=/usr/bin/happy"
78fi 106fi
79 107
80if [[ -n "${CABAL_USE_C2HS}" ]]; then 108if [[ -n "${CABAL_USE_C2HS}" ]]; then
81 DEPEND="${DEPEND} dev-haskell/c2hs" 109 DEPEND="${DEPEND} dev-haskell/c2hs"
82 cabalconf="${cabalconf} --with-c2hs=/usr/bin/c2hs"
83fi 110fi
84 111
85if [[ -n "${CABAL_USE_CPPHS}" ]]; then 112if [[ -n "${CABAL_USE_CPPHS}" ]]; then
86 DEPEND="${DEPEND} dev-haskell/cpphs" 113 DEPEND="${DEPEND} dev-haskell/cpphs"
87 cabalconf="${cabalconf} --with-cpphs=/usr/bin/cpphs"
88fi 114fi
89 115
90if [[ -n "${CABAL_USE_PROFILE}" ]]; then 116if [[ -n "${CABAL_USE_PROFILE}" ]]; then
91 IUSE="${IUSE} profile" 117 IUSE="${IUSE} profile"
92fi 118fi
112 if [[ "${CABAL_BOOTSTRAP}" ]]; then 138 if [[ "${CABAL_BOOTSTRAP}" ]]; then
113 # We're bootstrapping cabal, so the cabal version is the version 139 # We're bootstrapping cabal, so the cabal version is the version
114 # of this package itself. 140 # of this package itself.
115 _CABAL_VERSION_CACHE="${PV}" 141 _CABAL_VERSION_CACHE="${PV}"
116 elif [[ "${CABAL_FROM_GHC}" ]]; then 142 elif [[ "${CABAL_FROM_GHC}" ]]; then
117 # We can't assume there's a version of Cabal installed by ebuild as 143 local cabal_package=$(echo "$(ghc-libdir)"/Cabal-*)
118 # this might be a first time install of GHC (for packages that 144 # /path/to/ghc/Cabal-${VER} -> ${VER}
119 # use the shipped Cabal like haskell-updater). 145 _CABAL_VERSION_CACHE="${cabal_package/*Cabal-/}"
120
121 # The user is likely to only have one version of Cabal, provided
122 # by GHC. Note that dev-haskell/cabal can be a dummy package, only
123 # using the version provided by GHC. If the user has another version
124 # of Cabal too (more recent than the one GHC provides through
125 # dev-haskell/cabal, or possibly older if he used an old
126 # Cabal package) the most recent is used (expected to be the last
127 # one in the ghc-pkg output).
128 _CABAL_VERSION_CACHE="$(ghc-pkg field Cabal version | tail -n 1)"
129
130 # Strip out the "version: " prefix
131 _CABAL_VERSION_CACHE="${_CABAL_VERSION_CACHE#"version: "}"
132 else 146 else
133 # We ask portage, not ghc, so that we only pick up 147 # We ask portage, not ghc, so that we only pick up
134 # portage-installed cabal versions. 148 # portage-installed cabal versions.
135 _CABAL_VERSION_CACHE="$(ghc-extractportageversion dev-haskell/cabal)" 149 _CABAL_VERSION_CACHE="$(ghc-extractportageversion dev-haskell/cabal)"
136 fi 150 fi
158 else 172 else
159 # older ghc's don't support package versioning 173 # older ghc's don't support package versioning
160 cabalpackage=Cabal 174 cabalpackage=Cabal
161 fi 175 fi
162 einfo "Using cabal-$(cabal-version)." 176 einfo "Using cabal-$(cabal-version)."
177
178 make_setup() {
163 $(ghc-getghc) -package "${cabalpackage}" --make "${setupmodule}" -o setup \ 179 set -- -package "${cabalpackage}" --make "${setupmodule}" \
180 ${GHC_BOOTSTRAP_FLAGS} \
181 "$@" \
182 -o setup
183 echo $(ghc-getghc) "$@"
184 $(ghc-getghc) "$@"
185 }
186 if $(ghc-supports-shared-libraries); then
187 # some custom build systems might use external libraries,
188 # for which we don't have shared libs, so keep static fallback
189 make_setup -dynamic "$@" || make_setup "$@" || die "compiling ${setupmodule} failed"
190 else
164 || die "compiling ${setupmodule} failed" 191 make_setup "$@" || die "compiling ${setupmodule} failed"
192 fi
165} 193}
166 194
167cabal-mksetup() { 195cabal-mksetup() {
168 local setupdir 196 local setupdir
169 197
177 205
178 echo 'import Distribution.Simple; main = defaultMainWithHooks defaultUserHooks' \ 206 echo 'import Distribution.Simple; main = defaultMainWithHooks defaultUserHooks' \
179 > $setupdir/Setup.hs 207 > $setupdir/Setup.hs
180} 208}
181 209
210cabal-hscolour() {
211 set -- hscolour "$@"
212 echo ./setup "$@"
213 ./setup "$@" || die "setup hscolour failed"
214}
215
182cabal-haddock() { 216cabal-haddock() {
183 ./setup haddock || die "setup haddock failed" 217 set -- haddock "$@"
218 echo ./setup "$@"
219 ./setup "$@" || die "setup haddock failed"
220}
221
222cabal-hscolour-haddock() {
223 # --hyperlink-source implies calling 'setup hscolour'
224 set -- haddock --hyperlink-source
225 echo ./setup "$@"
226 ./setup "$@" --hyperlink-source || die "setup haddock --hyperlink-source failed"
184} 227}
185 228
186cabal-configure() { 229cabal-configure() {
230 has "${EAPI:-0}" 0 1 2 && ! use prefix && EPREFIX=
231
187 if [[ -n "${CABAL_USE_HADDOCK}" ]] && use doc; then 232 if [[ -n "${CABAL_USE_HADDOCK}" ]] && use doc; then
188 cabalconf="${cabalconf} --with-haddock=/usr/bin/haddock" 233 cabalconf="${cabalconf} --with-haddock=${EPREFIX}/usr/bin/haddock"
189 fi 234 fi
190 if [[ -n "${CABAL_USE_PROFILE}" ]] && use profile; then 235 if [[ -n "${CABAL_USE_PROFILE}" ]] && use profile; then
191 cabalconf="${cabalconf} --enable-library-profiling" 236 cabalconf="${cabalconf} --enable-library-profiling"
192 fi 237 fi
238 if [[ -n "${CABAL_USE_ALEX}" ]]; then
239 cabalconf="${cabalconf} --with-alex=${EPREFIX}/usr/bin/alex"
240 fi
241
242 if [[ -n "${CABAL_USE_HAPPY}" ]]; then
243 cabalconf="${cabalconf} --with-happy=${EPREFIX}/usr/bin/happy"
244 fi
245
246 if [[ -n "${CABAL_USE_C2HS}" ]]; then
247 cabalconf="${cabalconf} --with-c2hs=${EPREFIX}/usr/bin/c2hs"
248 fi
249 if [[ -n "${CABAL_USE_CPPHS}" ]]; then
250 cabalconf="${cabalconf} --with-cpphs=${EPREFIX}/usr/bin/cpphs"
251 fi
252
193 # Building GHCi libs on ppc64 causes "TOC overflow". 253 # Building GHCi libs on ppc64 causes "TOC overflow".
194 if use ppc64; then 254 if use ppc64; then
195 cabalconf="${cabalconf} --disable-library-for-ghci" 255 cabalconf="${cabalconf} --disable-library-for-ghci"
196 fi 256 fi
257
258 # currently cabal does not respect CFLAGS and LDFLAGS on it's own (bug #333217)
259 # so translate LDFLAGS to ghc parameters (without filtering)
260 local flag
261 for flag in $LDFLAGS; do cabalconf="${cabalconf} --ghc-option=-optl$flag"; done
197 262
198 if version_is_at_least "1.4" "$(cabal-version)"; then 263 if version_is_at_least "1.4" "$(cabal-version)"; then
199 # disable executable stripping for the executables, as portage will 264 # disable executable stripping for the executables, as portage will
200 # strip by itself, and pre-stripping gives a QA warning. 265 # strip by itself, and pre-stripping gives a QA warning.
201 # cabal versions previous to 1.4 does not strip executables, and does 266 # cabal versions previous to 1.4 does not strip executables, and does
204 # bug #251881, bug #251882, bug #251884, bug #251886, bug #299494 269 # bug #251881, bug #251882, bug #251884, bug #251886, bug #299494
205 cabalconf="${cabalconf} --disable-executable-stripping" 270 cabalconf="${cabalconf} --disable-executable-stripping"
206 fi 271 fi
207 272
208 if version_is_at_least "1.2.0" "$(cabal-version)"; then 273 if version_is_at_least "1.2.0" "$(cabal-version)"; then
209 cabalconf="${cabalconf} --docdir=/usr/share/doc/${PF}" 274 cabalconf="${cabalconf} --docdir=${EPREFIX}/usr/share/doc/${PF}"
210 # As of Cabal 1.2, configure is quite quiet. For diagnostic purposes 275 # As of Cabal 1.2, configure is quite quiet. For diagnostic purposes
211 # it's better if the configure chatter is in the build logs: 276 # it's better if the configure chatter is in the build logs:
212 cabalconf="${cabalconf} --verbose" 277 cabalconf="${cabalconf} --verbose"
213 fi 278 fi
214 # Note: with Cabal-1.1.6.x we do not have enough control 279 # Note: with Cabal-1.1.6.x we do not have enough control
215 # to put the docs into the right place. They're currently going 280 # to put the docs into the right place. They're currently going
216 # into /usr/share/${P}/ghc-x.y/doc/ 281 # into /usr/share/${P}/ghc-x.y/doc/
217 # rather than /usr/share/doc/${PF}/ 282 # rather than /usr/share/doc/${PF}/
218 # Because we can only set the datadir, not the docdir. 283 # Because we can only set the datadir, not the docdir.
219 284
285 # We build shared version of our Cabal where ghc ships it's shared
286 # version of it. We will link ./setup as dynamic binary againt Cabal later.
287 [[ ${CATEGORY}/${PN} == "dev-haskell/cabal" ]] && \
288 $(ghc-supports-shared-libraries) && \
289 cabalconf="${cabalconf} --enable-shared"
290
220 ./setup configure \ 291 set -- configure \
221 --ghc --prefix=/usr \ 292 --ghc --prefix="${EPREFIX}"/usr \
222 --with-compiler="$(ghc-getghc)" \ 293 --with-compiler="$(ghc-getghc)" \
223 --with-hc-pkg="$(ghc-getghcpkg)" \ 294 --with-hc-pkg="$(ghc-getghcpkg)" \
224 --prefix=/usr \ 295 --prefix="${EPREFIX}"/usr \
225 --libdir=/usr/$(get_libdir) \ 296 --libdir="${EPREFIX}"/usr/$(get_libdir) \
226 --libsubdir=${P}/ghc-$(ghc-version) \ 297 --libsubdir=${P}/ghc-$(ghc-version) \
227 --datadir=/usr/share/ \ 298 --datadir="${EPREFIX}"/usr/share/ \
228 --datasubdir=${P}/ghc-$(ghc-version) \ 299 --datasubdir=${P}/ghc-$(ghc-version) \
229 ${cabalconf} \ 300 ${cabalconf} \
230 ${CABAL_CONFIGURE_FLAGS} \ 301 ${CABAL_CONFIGURE_FLAGS} \
302 ${CABAL_EXTRA_CONFIGURE_FLAGS} \
303 "$@"
304 echo ./setup "$@"
231 "$@" || die "setup configure failed" 305 ./setup "$@" || die "setup configure failed"
232} 306}
233 307
234cabal-build() { 308cabal-build() {
235 unset LANG LC_ALL LC_MESSAGES 309 unset LANG LC_ALL LC_MESSAGES
236 ./setup build \ 310 set -- build "$@"
311 echo ./setup "$@"
312 ./setup "$@" \
237 || die "setup build failed" 313 || die "setup build failed"
238} 314}
239 315
240cabal-copy() { 316cabal-copy() {
241 ./setup copy \ 317 has "${EAPI:-0}" 0 1 2 && ! use prefix && ED=${D}
242 --destdir="${D}" \ 318
319 set -- copy --destdir="${D}" "$@"
320 echo ./setup "$@"
243 || die "setup copy failed" 321 ./setup "$@" || die "setup copy failed"
244 322
245 # cabal is a bit eager about creating dirs, 323 # cabal is a bit eager about creating dirs,
246 # so remove them if they are empty 324 # so remove them if they are empty
247 rmdir "${D}/usr/bin" 2> /dev/null 325 rmdir "${ED}/usr/bin" 2> /dev/null
248 326
249 # GHC 6.4 has a bug in get/setPermission and Cabal 1.1.1 has 327 # GHC 6.4 has a bug in get/setPermission and Cabal 1.1.1 has
250 # no workaround. 328 # no workaround.
251 # set the +x permission on executables 329 # set the +x permission on executables
252 if [[ -d "${D}/usr/bin" ]] ; then 330 if [[ -d "${ED}/usr/bin" ]] ; then
253 chmod +x "${D}/usr/bin/"* 331 chmod +x "${ED}/usr/bin/"*
254 fi 332 fi
255 # TODO: do we still need this? 333 # TODO: do we still need this?
256} 334}
257 335
258cabal-pkg() { 336cabal-pkg() {
318 if cabal-is-dummy-lib; then 396 if cabal-is-dummy-lib; then
319 einfo "${P} is included in ghc-${CABAL_CORE_LIB_GHC_PV}, nothing to install." 397 einfo "${P} is included in ghc-${CABAL_CORE_LIB_GHC_PV}, nothing to install."
320 fi 398 fi
321} 399}
322 400
401haskell-cabal_src_configure() {
402 if ! cabal-is-dummy-lib; then
403 pushd "${S}" > /dev/null
404
405 cabal-bootstrap
406
407 cabal-configure $ghc_flags "$@"
408
409 popd > /dev/null
410 fi
411}
412
413# exported function: nice alias
414cabal_src_configure() {
415 haskell-cabal_src_configure "$@"
416}
417
323# exported function: cabal-style bootstrap configure and compile 418# exported function: cabal-style bootstrap configure and compile
324cabal_src_compile() { 419cabal_src_compile() {
420 # it's a common mistake when one bumps ebuild to EAPI="2" (and upper)
421 # and forgets to separate src_compile() to src_configure()/src_compile().
422 # Such error leads to default src_configure and we lose all passed flags.
423 if ! has "${EAPI:-0}" 0 1; then
424 local passed_flag
425 for passed_flag in "$@"; do
426 [[ ${passed_flag} == --flags=* ]] && \
427 eqawarn "Cabal option '${passed_flag}' has effect only in src_configure()"
428 done
429 fi
430
325 if ! cabal-is-dummy-lib; then 431 if ! cabal-is-dummy-lib; then
326 cabal-bootstrap 432 has src_configure ${HASKELL_CABAL_EXPF} || haskell-cabal_src_configure "$@"
327 cabal-configure
328 cabal-build 433 cabal-build
329 434
330 if [[ -n "${CABAL_USE_HADDOCK}" ]] && use doc; then 435 if [[ -n "${CABAL_USE_HADDOCK}" ]] && use doc; then
436 if [[ -n "${CABAL_USE_HSCOLOUR}" ]] && use hscolour; then
437 # hscolour and haddock
438 cabal-hscolour-haddock
439 else
440 # just haddock
331 cabal-haddock 441 cabal-haddock
442 fi
443 else
444 if [[ -n "${CABAL_USE_HSCOLOUR}" ]] && use hscolour; then
445 # just hscolour
446 cabal-hscolour
447 fi
332 fi 448 fi
333 fi 449 fi
334} 450}
335 451
336haskell-cabal_src_compile() { 452haskell-cabal_src_compile() {
453 pushd "${S}" > /dev/null
454
337 cabal_src_compile 455 cabal_src_compile "$@"
456
457 popd > /dev/null
458}
459
460haskell-cabal_src_test() {
461 pushd "${S}" > /dev/null
462
463 if cabal-is-dummy-lib; then
464 einfo ">>> No tests for dummy library: ${CATEGORY}/${PF}"
465 else
466 einfo ">>> Test phase [cabal test]: ${CATEGORY}/${PF}"
467 set -- test "$@"
468 echo ./setup "$@"
469 ./setup "$@" || die "cabal test failed"
470 fi
471
472 popd > /dev/null
338} 473}
339 474
340# exported function: cabal-style copy and register 475# exported function: cabal-style copy and register
341cabal_src_install() { 476cabal_src_install() {
477 has "${EAPI:-0}" 0 1 2 && ! use prefix && EPREFIX=
478
342 if cabal-is-dummy-lib; then 479 if cabal-is-dummy-lib; then
343 # create a dummy local package conf file for the sake of ghc-updater 480 # create a dummy local package conf file for the sake of ghc-updater
344 dodir "$(ghc-confdir)" 481 local ghc_confdir_with_prefix="$(ghc-confdir)"
482 # remove EPREFIX
483 dodir ${ghc_confdir_with_prefix#${EPREFIX}}
345 echo '[]' > "${D}/$(ghc-confdir)/$(ghc-localpkgconf)" 484 echo '[]' > "${D}/$(ghc-confdir)/$(ghc-localpkgconf)"
346 else 485 else
347 cabal-copy 486 cabal-copy
348 cabal-pkg 487 cabal-pkg
349 488
352 dohtml -r dist/doc/html/* 491 dohtml -r dist/doc/html/*
353 fi 492 fi
354 fi 493 fi
355 fi 494 fi
356} 495}
496
357haskell-cabal_src_install() { 497haskell-cabal_src_install() {
498 pushd "${S}" > /dev/null
499
358 cabal_src_install 500 cabal_src_install
359}
360 501
361EXPORT_FUNCTIONS pkg_setup src_compile src_install 502 popd > /dev/null
503}
504
505# ebuild.sh:use_enable() taken as base
506#
507# Usage examples:
508#
509# CABAL_CONFIGURE_FLAGS=$(cabal_flag gui)
510# leads to "--flags=gui" or "--flags=-gui" (useflag 'gui')
511#
512# CABAL_CONFIGURE_FLAGS=$(cabal_flag gtk gui)
513# also leads to "--flags=gui" or " --flags=-gui" (useflag 'gtk')
514#
515cabal_flag() {
516 if [[ -z "$1" ]]; then
517 echo "!!! cabal_flag() called without a parameter." >&2
518 echo "!!! cabal_flag() <USEFLAG> [<cabal_flagname>]" >&2
519 return 1
520 fi
521
522 local UWORD=${2:-$1}
523
524 if use "$1"; then
525 echo "--flags=${UWORD}"
526 else
527 echo "--flags=-${UWORD}"
528 fi
529
530 return 0
531}

Legend:
Removed from v.1.18  
changed lines
  Added in v.1.26

  ViewVC Help
Powered by ViewVC 1.1.20